#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
int gcd(int a, int b) { return b == 0 ? a : gcd(b, a % b); }
int main()
{
    int n, a, b, c, d;
    scanf("%d", &n);
    while (n--)
    {
        scanf("%d%d", &a, &c);
        if (c % a)
            puts("NO SOLUTION");
        else
        {
            b = c / a;
            while ((d = gcd(a, b)) != 1)
            {
                b *= d;
                a /= d;
                d = gcd(a, b);
            }
            printf("%d\n", b);
        }
    }
    return 0;
}